---
title: Used value
slug: Web/CSS/used_value
tags:
  - CSS
  - Guide
  - Reference
---
<div>{{cssref}}</div>

<p>The <strong>used value</strong> of a <a href="/en-US/docs/Web/CSS">CSS</a> property is its value after all calculations have been performed on the <a href="/en-US/docs/Web/CSS/computed_value">computed value</a>.</p>

<p>After the {{glossary("user agent")}} has finished its calculations, every CSS property has a used value. The used values of dimensions (e.g., {{cssxref("width")}}, {{cssxref("line-height")}}) are in pixels. The used values of shorthand properties (e.g., {{cssxref("background")}}) are consistent with those of their component properties (e.g., {{cssxref("background-color")}} or {{cssxref("background-size")}}) and with {{cssxref("position")}} and {{cssxref("float")}}.</p>

<div class="note">
<p><strong>Note:</strong> The {{domxref("Window.getComputedStyle", "getComputedStyle()")}} DOM API returns the <a href="/en-US/docs/Web/CSS/resolved_value">resolved value</a>, which may either be the <a href="/en-US/docs/Web/CSS/computed_value">computed value</a> or the <a href="/en-US/docs/Web/CSS/used_value">used value</a>, depending on the property.</p>
</div>

<h2 id="Example">Example</h2>

<p>This example computes and displays the used <code>width</code> value of three elements (updates on resize):</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;div id="no-width"&gt;
  &lt;p&gt;No explicit width.&lt;/p&gt;
  &lt;p class="show-used-width"&gt;..&lt;/p&gt;

  &lt;div id="width-50"&gt;
    &lt;p&gt;Explicit width: 50%.&lt;/p&gt;
    &lt;p class="show-used-width"&gt;..&lt;/p&gt;

    &lt;div id="width-inherit"&gt;
      &lt;p&gt;Explicit width: inherit.&lt;/p&gt;
      &lt;p class="show-used-width"&gt;..&lt;/p&gt;
    &lt;/div&gt;
  &lt;/div&gt;
&lt;/div&gt;
</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">#no-width {
  width: auto;
}

#width-50 {
  width: 50%;
}

#width-inherit {
  width: inherit;
}

/* Make results easier to see */
div {
  border: 1px solid red;
  padding: 8px;
}</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">function updateUsedWidth(id) {
  var div = document.querySelector(`#${id}`);
  var par = div.querySelector('.show-used-width');
  var wid = window.getComputedStyle(div)["width"];
  par.textContent = `Used width: ${wid}.`;
}

function updateAllUsedWidths() {
  updateUsedWidth("no-width");
  updateUsedWidth("width-50");
  updateUsedWidth("width-inherit");
}

updateAllUsedWidths();
window.addEventListener('resize', updateAllUsedWidths);
</pre>

<h3 id="Result">Result</h3>

<p>{{ EmbedLiveSample('Example', '80%', 372) }}</p>

<h2 id="Difference_from_computed_value">Difference from computed value</h2>

<p>CSS 2.0 defined only <em>computed value</em> as the last step in a property's calculation. Then, CSS 2.1 introduced the distinct definition of used value. An element could then explicitly inherit a width/height of a parent, whose computed value is a percentage. For CSS properties that don't depend on layout (e.g., <code>display</code>, <code>font-size</code>, or <code>line-height</code>), the computed values and used values are the same. The following are the CSS 2.1 properties that do depend on layout, so they have a different computed value and used value: (taken from <a class="external" href="https://www.w3.org/TR/CSS2/changes.html#q21.36">CSS 2.1 Changes: Specified, computed, and actual values</a>):</p>

<ul>
 <li><code>background-position</code></li>
 <li><code>bottom</code>, <code>left</code>, <code>right</code>, <code>top</code></li>
 <li><code>height</code>, <code>width</code></li>
 <li><code>margin-bottom</code>, <code>margin-left</code>, <code>margin-right</code>, <code>margin-top</code></li>
 <li><code>min-height</code>, <code>min-width</code></li>
 <li><code>padding-bottom</code>, <code>padding-left</code>, <code>padding-right</code>, <code>padding-top</code></li>
 <li><code>text-indent</code></li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS2.2", "cascade.html#used-value", "used value")}}</td>
   <td>{{Spec2("CSS2.2")}}</td>
   <td>
    <p>No change.</p>
   </td>
  </tr>
  <tr>
   <td>{{SpecName("CSS2.1", "cascade.html#used-value", "used value")}}</td>
   <td>{{Spec2("CSS2.1")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("window.getComputedStyle")}}</li>
 <li>{{CSS_key_concepts}}</li>
</ul>
